/**
 * @(#)Navigator.java  12/12/99
 * @author Peter Au
 * All rights reserved.
 */

package vishnu.testvis.treemap.visual;
import vishnu.testvis.visual.*;
import vishnu.testvis.visual.Vishnu;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.text.html.*;
import javax.swing.border.BevelBorder;


public class TMNavigator extends JPanel
{
    final private int _TREEMAPWIDTH=300, _TREEMAPHEIGHT=350;
    public final static int LIST_ON_LEFT = 0;
    public final static int LIST_ON_RIGHT = 1;
    private int listPos;

//    JTextField _searchTF = new JTextField();
//    JButton _searchButton = new JButton("Search");
    public Vishnu _displayFrame;
    JScrollPane _displayJSP = new JScrollPane();
    JEditorPane _displayJEP = new JEditorPane();
    JTable _table = new JTable();
    JButton _showAllButton = new JButton("Show All Documents");
    JButton _refineButton = new JButton("Filter");
    NavigatorPanel navigator;
//  = new NavigatorPanel(_table, _showAllButton, _refineButton, _displayJEP, this,_codeBase);

    JButton _backButton = new JButton("<<   Back");
    TreemapPanel _treemapPanel;
//  = new TreemapPanel(_TREEMAPWIDTH,_TREEMAPHEIGHT, _backButton, navigator, _codeBase);



	public TMNavigator(Vishnu displayFrame, int listPos)
    {
   	    _displayFrame = displayFrame;
   	    this.listPos = listPos;
   	    
        navigator = new NavigatorPanel(_table, /*_showAllButton*/ _refineButton, _displayJEP, this);
        _treemapPanel = new TreemapPanel(_TREEMAPWIDTH,_TREEMAPHEIGHT, _backButton, navigator, _displayFrame);
        
        buildGUI();
        
	    setSize(_TREEMAPWIDTH*2+40,_TREEMAPHEIGHT+340);
        //setVisible(false);
	    //setupEventHandler();
	}

    public void setVisible(boolean f)
    {
        super.setVisible(f);
        _treemapPanel.setVisible(f);
    }

    void buildGUI()
    {
        JPanel tmpPanel;
        JScrollPane tmpJSP;

        //this.setLayout(new FlowLayout(FlowLayout.LEFT,10,10));
        this.setLayout(null);
//        _searchTF.setFont(new Font("Courier",Font.BOLD,16));
//        _searchTF.setBounds(10,10,400,30);
//        add(_searchTF,null);

//        _searchButton.setActionCommand("search");
//        _searchButton.setBounds(10+400+10,10,100,30);
//        add(_searchButton,null);
        _backButton.setBorder(BorderFactory.createEtchedBorder());
        _backButton.setFont(new java.awt.Font("Monospaced", 0, 12));
        _backButton.setBounds(10+_TREEMAPWIDTH+10,10+_TREEMAPHEIGHT+10,200,30);
        add(_backButton,null);

        if( listPos == 0 ) // list on left
        {
            tmpPanel = newJPanel(_treemapPanel,Color.gray,
            10,10,_TREEMAPWIDTH+3,_TREEMAPHEIGHT+2);
            add(tmpPanel,null);
        }
        if( listPos == 1 ) // list on right
        {
            tmpPanel = newJPanel(_treemapPanel,Color.gray,
            10+_TREEMAPWIDTH+10,10,_TREEMAPWIDTH+3,_TREEMAPHEIGHT+2);
            add(tmpPanel,null);
        }


        _displayJEP.setEditorKit(new HTMLEditorKit());
        _displayJEP.setEditable(false);
        Dimension sSize=this.getToolkit().getScreenSize();
        tmpJSP = new JScrollPane();
        tmpJSP.getViewport().add(_displayJEP);
        tmpPanel = newJPanel(tmpJSP, Color.white,
            10, 10+_TREEMAPHEIGHT+10+30+10, _TREEMAPWIDTH*2+10,
            sSize.height>700?200:85);
        add(tmpPanel,null);

        //-- manually creating the columns
        _table.setAutoCreateColumnsFromModel(false);
        _table.getColumnModel().getColumn(0).setPreferredWidth(20);
        _table.getColumnModel().getColumn(1).setPreferredWidth(_TREEMAPWIDTH*2/3);
        _table.getColumnModel().getColumn(2).setPreferredWidth(_TREEMAPWIDTH/3);
        _table.setRowSelectionAllowed(false);
        tmpJSP = new JScrollPane();
        tmpJSP.getViewport().add(_table);
        
        if( listPos == 0 )
        {
            tmpPanel = newJPanel(tmpJSP, Color.white,
            10+_TREEMAPWIDTH+10, 10, _TREEMAPWIDTH, _TREEMAPHEIGHT+2);
            add(tmpPanel,null);
        }
        if( listPos == 1 )
        {
            tmpPanel = newJPanel(tmpJSP, Color.white,
            10, 10, _TREEMAPWIDTH, _TREEMAPHEIGHT+2);
            add(tmpPanel,null);
        }
        
        
        _showAllButton.setFont(new java.awt.Font("Monospaced", 0, 12));
        _showAllButton.setBounds(10+_TREEMAPWIDTH+10,10+_TREEMAPHEIGHT+10,200,30);
        _showAllButton.setBorder(BorderFactory.createEtchedBorder());
        //add(_showAllButton,null);

        _refineButton.setFont(new java.awt.Font("Monospaced", 0, 12));
        _refineButton.setBounds(10+_TREEMAPWIDTH+10+200,10+_TREEMAPHEIGHT+10,100,30);
        _refineButton.setBorder(BorderFactory.createEtchedBorder());
        add(_refineButton,null);

    }


    private JPanel newJPanel(Component c, Color bg,int x, int y, int w, int h)
    {
        JPanel p = new JPanel();
        p.setBorder(new BevelBorder(BevelBorder.LOWERED));
        p.setLayout(new BorderLayout());
        p.setBounds(x,y,w,h);
        p.setBackground(bg);
        p.add(c,BorderLayout.CENTER);
        return p;
  }

    public void update()
    {
        _treemapPanel.newSearch();
    }



}
